Index: trunk/LMDZ.MARS/libf/aeronomars/jthermcalc_e107.F
===================================================================
--- trunk/LMDZ.MARS/libf/aeronomars/jthermcalc_e107.F	(revision 1265)
+++ trunk/LMDZ.MARS/libf/aeronomars/jthermcalc_e107.F	(revision 1266)
@@ -2,5 +2,5 @@
 
       subroutine jthermcalc_e107
-     $     (ig,chemthermod,rm,nesptherm,tx,iz,zenit,zday)
+     $     (ig,nlayer,chemthermod,rm,nesptherm,tx,iz,zenit,zday)
 
 
@@ -12,21 +12,22 @@
 c**********************************************************************
 
+      use param_v4_h, only: jfotsout,crscabsi2,
+     .    c1_16,c17_24,c25_29,c30_31,c32,c33,c34,c35,c36,
+     .    co2crsc195,co2crsc295,t0,
+     .    jabsifotsintpar,ninter,nz2,
+     .    nabs,e107,date_e107,e107_tab,
+     .    coefit0,coefit1,coefit2,coefit3,coefit4
+
       implicit none
 
-c     common variables and constants
-      include "dimensions.h"
-      include "dimphys.h"
-      include 'param.h'
-      include 'param_v4.h'
-
 c     input and output variables
 
-      integer    ig
+      integer    ig,nlayer
       integer    chemthermod
       integer    nesptherm                      !Number of species considered
-      real       rm(nlayermx,nesptherm)         !Densities (cm-3)
-      real       tx(nlayermx)                   !temperature
+      real       rm(nlayer,nesptherm)         !Densities (cm-3)
+      real       tx(nlayer)                   !temperature
       real       zenit                          !SZA
-      real       iz(nlayermx)                   !Local altitude
+      real       iz(nlayer)                   !Local altitude
       real       zday                           !Martian day after Ls=0
 
@@ -34,21 +35,21 @@
 c    local parameters and variables
 
-      real       co2colx(nlayermx)              !column density of CO2 (cm^-2)
-      real       o2colx(nlayermx)               !column density of O2(cm^-2)
-      real       o3pcolx(nlayermx)              !column density of O(3P)(cm^-2)
-      real       h2colx(nlayermx)               !H2 column density (cm-2)
-      real       h2ocolx(nlayermx)              !H2O column density (cm-2)
-      real       h2o2colx(nlayermx)             !column density of H2O2(cm^-2)
-      real       o3colx(nlayermx)               !O3 column density (cm-2)
-      real       n2colx(nlayermx)               !N2 column density (cm-2)
-      real       ncolx(nlayermx)                !N column density (cm-2)
-      real       nocolx(nlayermx)               !NO column density (cm-2)
-      real       cocolx(nlayermx)               !CO column density (cm-2)
-      real       hcolx(nlayermx)                !H column density (cm-2)
-      real       no2colx(nlayermx)              !NO2 column density (cm-2)
-      real       t2(nlayermx)
-      real       coltemp(nlayermx)
-      real       sigma(ninter,nlayermx)
-      real       alfa(ninter,nlayermx)
+      real       co2colx(nlayer)              !column density of CO2 (cm^-2)
+      real       o2colx(nlayer)               !column density of O2(cm^-2)
+      real       o3pcolx(nlayer)              !column density of O(3P)(cm^-2)
+      real       h2colx(nlayer)               !H2 column density (cm-2)
+      real       h2ocolx(nlayer)              !H2O column density (cm-2)
+      real       h2o2colx(nlayer)             !column density of H2O2(cm^-2)
+      real       o3colx(nlayer)               !O3 column density (cm-2)
+      real       n2colx(nlayer)               !N2 column density (cm-2)
+      real       ncolx(nlayer)                !N column density (cm-2)
+      real       nocolx(nlayer)               !NO column density (cm-2)
+      real       cocolx(nlayer)               !CO column density (cm-2)
+      real       hcolx(nlayer)                !H column density (cm-2)
+      real       no2colx(nlayer)              !NO2 column density (cm-2)
+      real       t2(nlayer)
+      real       coltemp(nlayer)
+      real       sigma(ninter,nlayer)
+      real       alfa(ninter,nlayer)
       real       realday
       
@@ -75,10 +76,10 @@
       real*8      auxjh(nz2)
       real*8      auxjno2(nz2)
-      real*8      wp(nlayermx),wm(nlayermx)
-      real*8      auxcolinp(nlayermx)
-      integer     auxind(nlayermx)
+      real*8      wp(nlayer),wm(nlayer)
+      real*8      auxcolinp(nlayer)
+      integer     auxind(nlayer)
       integer     auxi
       integer     ind
-      real*8      cortemp(nlayermx)
+      real*8      cortemp(nlayer)
 
       real*8      limdown                      !limits for interpolation
@@ -106,5 +107,5 @@
       !Auxiliar temperature to take into account the temperature dependence
       !of CO2 cross section
-      do i=1,nlayermx
+      do i=1,nlayer
          t2(i)=tx(i)
          if(t2(i).lt.195.0) t2(i)=195.0
@@ -113,5 +114,5 @@
 
       !Calculation of column amounts 
-      call column(ig,chemthermod,rm,nesptherm,tx,iz,zenit,
+      call column(ig,nlayer,chemthermod,rm,nesptherm,tx,iz,zenit,
      $     co2colx,o2colx,o3pcolx,h2colx,h2ocolx,
      $     h2o2colx,o3colx,n2colx,ncolx,nocolx,cocolx,hcolx,no2colx)
@@ -119,6 +120,6 @@
       !Auxiliar column to include the temperature dependence 
       !of CO2 cross section
-      coltemp(nlayermx)=co2colx(nlayermx)*abs(t2(nlayermx)-t0(nlayermx))
-      do i=nlayermx-1,1,-1
+      coltemp(nlayer)=co2colx(nlayer)*abs(t2(nlayer)-t0(nlayer))
+      do i=nlayer-1,1,-1
         coltemp(i)=!coltemp(i+1)+     PQ SE ELIMINA? REVISAR 
      $         ( rm(i,i_co2) + rm(i+1,i_co2) ) * 0.5 
@@ -127,5 +128,5 @@
       
       !Calculation of CO2 cross section at temperature t0(i)
-      do i=1,nlayermx
+      do i=1,nlayer
          do indexint=24,32
            sigma(indexint,i)=co2crsc195(indexint-23)
@@ -157,5 +158,5 @@
       do j=1,nabs
          do indexint=1,ninter
-            jfotsout(indexint,j,nlayermx)=coefit0(indexint,j)+
+            jfotsout(indexint,j,nlayer)=coefit0(indexint,j)+
      $           coefit1(indexint,j)*e107+coefit2(indexint,j)*e107**2+
      $           coefit3(indexint,j)*e107**3+coefit4(indexint,j)*e107**4
@@ -179,6 +180,6 @@
 c     Input atmospheric column
       indexint=1
-      do i=1,nlayermx
-         auxcolinp(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint) +
+      do i=1,nlayer
+         auxcolinp(nlayer-i+1) = co2colx(i)*crscabsi2(1,indexint) +
      $        o2colx(i)*crscabsi2(2,indexint) + 
      $        o3pcolx(i)*crscabsi2(3,indexint) + 
@@ -214,16 +215,16 @@
 
       call interfast 
-     $     (wm,wp,auxind,auxcolinp,nlayermx,auxcoltab,nz2,limdown,limup)
-      do i=1,nlayermx
+     $     (wm,wp,auxind,auxcolinp,nlayer,auxcoltab,nz2,limdown,limup)
+      do i=1,nlayer
          ind=auxind(i)
-         auxi=nlayermx-i+1
+         auxi=nlayer-i+1
          !CO2 interpolated coefficient
-         jfotsout(indexint,1,auxi) = jfotsout(indexint,1,nlayermx) *
+         jfotsout(indexint,1,auxi) = jfotsout(indexint,1,nlayer) *
      $        (wm(i)*auxjco2(ind+1) + wp(i)*auxjco2(ind))
          !O2 interpolated coefficient
-         jfotsout(indexint,2,auxi) = jfotsout(indexint,2,nlayermx) *
+         jfotsout(indexint,2,auxi) = jfotsout(indexint,2,nlayer) *
      $        (wm(i)*auxjo2(ind+1) + wp(i)*auxjo2(ind))
          !O3p interpolated coefficient
-         jfotsout(indexint,3,auxi) = jfotsout(indexint,3,nlayermx) *
+         jfotsout(indexint,3,auxi) = jfotsout(indexint,3,nlayer) *
      $        (wm(i)*auxjo3p(ind+1) + wp(i)*auxjo3p(ind))
          !H2 interpolated coefficient
@@ -234,8 +235,8 @@
       !N interpolated coefficient
       if(chemthermod.ge.2) then
-         do i=1,nlayermx
+         do i=1,nlayer
             ind=auxind(i)
-            jfotsout(indexint,9,nlayermx-i+1) =  
-     $           jfotsout(indexint,9,nlayermx) * 
+            jfotsout(indexint,9,nlayer-i+1) =  
+     $           jfotsout(indexint,9,nlayer) * 
      $           (wm(i)*auxjn(ind+1) + wp(i)*auxjn(ind))
          enddo
@@ -256,6 +257,6 @@
 c     Input atmospheric column
       do indexint=2,15
-         do i=1,nlayermx
-            auxcolinp(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint)+
+         do i=1,nlayer
+            auxcolinp(nlayer-i+1) = co2colx(i)*crscabsi2(1,indexint)+
      $           o2colx(i)*crscabsi2(2,indexint)+
      $           o3pcolx(i)*crscabsi2(3,indexint)+
@@ -303,54 +304,54 @@
          endif
 
-          call interfast(wm,wp,auxind,auxcolinp,nlayermx,
+          call interfast(wm,wp,auxind,auxcolinp,nlayer,
      $        auxcoltab,nz2,limdown,limup)
-          do i=1,nlayermx
+          do i=1,nlayer
              ind=auxind(i)
-             auxi = nlayermx-i+1
+             auxi = nlayer-i+1
              !O2 interpolated coefficient
              jfotsout(indexint,2,auxi) = 
-     $            jfotsout(indexint,2,nlayermx) *
+     $            jfotsout(indexint,2,nlayer) *
      $            (wm(i)*auxjo2(ind+1) + wp(i)*auxjo2(ind))
              !O3p interpolated coefficient
              jfotsout(indexint,3,auxi) = 
-     $            jfotsout(indexint,3,nlayermx) *
+     $            jfotsout(indexint,3,nlayer) *
      $            (wm(i)*auxjo3p(ind+1) + wp(i)*auxjo3p(ind))
              !CO2 interpolated coefficient
              jfotsout(indexint,1,auxi) = 
-     $            jfotsout(indexint,1,nlayermx) *
+     $            jfotsout(indexint,1,nlayer) *
      $            (wm(i)*auxjco2(ind+1) + wp(i)*auxjco2(ind))
              !H2 interpolated coefficient
              jfotsout(indexint,5,auxi) = 
-     $            jfotsout(indexint,5,nlayermx) *
+     $            jfotsout(indexint,5,nlayer) *
      $            (wm(i)*auxjh2(ind+1) + wp(i)*auxjh2(ind))
              !N2 interpolated coefficient
              jfotsout(indexint,8,auxi) = 
-     $            jfotsout(indexint,8,nlayermx) *
+     $            jfotsout(indexint,8,nlayer) *
      $            (wm(i)*auxjn2(ind+1) + wp(i)*auxjn2(ind))
              !CO interpolated coefficient
              jfotsout(indexint,11,auxi) = 
-     $            jfotsout(indexint,11,nlayermx) *
+     $            jfotsout(indexint,11,nlayer) *
      $            (wm(i)*auxjco(ind+1) + wp(i)*auxjco(ind))
              !H interpolated coefficient
              jfotsout(indexint,12,auxi) = 
-     $            jfotsout(indexint,12,nlayermx) *
+     $            jfotsout(indexint,12,nlayer) *
      $            (wm(i)*auxjh(ind+1) + wp(i)*auxjh(ind))
           enddo
           !Only if chemthermod.ge.2
           if(chemthermod.ge.2) then
-             do i=1,nlayermx
+             do i=1,nlayer
                 ind=auxind(i)
-                auxi = nlayermx-i+1
+                auxi = nlayer-i+1
                 !N interpolated coefficient
                 jfotsout(indexint,9,auxi) = 
-     $               jfotsout(indexint,9,nlayermx) *
+     $               jfotsout(indexint,9,nlayer) *
      $               (wm(i)*auxjn(ind+1) + wp(i)*auxjn(ind))
                 !NO interpolated coefficient
                 jfotsout(indexint,10,auxi)=
-     $               jfotsout(indexint,10,nlayermx) *
+     $               jfotsout(indexint,10,nlayer) *
      $               (wm(i)*auxjno(ind+1) + wp(i)*auxjno(ind))
                 !NO2 interpolated coefficient
                 jfotsout(indexint,13,auxi)=
-     $               jfotsout(indexint,13,nlayermx) *
+     $               jfotsout(indexint,13,nlayer) *
      $               (wm(i)*auxjno2(ind+1) + wp(i)*auxjno2(ind))
              enddo
@@ -371,6 +372,6 @@
 c     Input atmospheric column
       indexint=16
-      do i=1,nlayermx
-         auxcolinp(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint)+
+      do i=1,nlayer
+         auxcolinp(nlayer-i+1) = co2colx(i)*crscabsi2(1,indexint)+
      $        o2colx(i)*crscabsi2(2,indexint)+
      $        o3pcolx(i)*crscabsi2(3,indexint)+
@@ -418,45 +419,45 @@
 
       call interfast
-     $     (wm,wp,auxind,auxcolinp,nlayermx,auxcoltab,nz2,limdown,limup)
-      do i=1,nlayermx
+     $     (wm,wp,auxind,auxcolinp,nlayer,auxcoltab,nz2,limdown,limup)
+      do i=1,nlayer
          ind=auxind(i)
-         auxi = nlayermx-i+1
+         auxi = nlayer-i+1
          !O2 interpolated coefficient
-         jfotsout(indexint,2,auxi) = jfotsout(indexint,2,nlayermx) *
+         jfotsout(indexint,2,auxi) = jfotsout(indexint,2,nlayer) *
      $        (wm(i)*auxjo2(ind+1) + wp(i)*auxjo2(ind))
          !CO2 interpolated coefficient
-         jfotsout(indexint,1,auxi) = jfotsout(indexint,1,nlayermx) *
+         jfotsout(indexint,1,auxi) = jfotsout(indexint,1,nlayer) *
      $        (wm(i)*auxjco2(ind+1) + wp(i)*auxjco2(ind))
          !O3p interpolated coefficient
-         jfotsout(indexint,3,auxi) = jfotsout(indexint,3,nlayermx) *
+         jfotsout(indexint,3,auxi) = jfotsout(indexint,3,nlayer) *
      $        (wm(i)*auxjo3p(ind+1) + wp(i)*auxjo3p(ind))
          !N2 interpolated coefficient
-         jfotsout(indexint,8,auxi) = jfotsout(indexint,8,nlayermx) *
+         jfotsout(indexint,8,auxi) = jfotsout(indexint,8,nlayer) *
      $        (wm(i)*auxjn2(ind+1) + wp(i)*auxjn2(ind))
          !CO interpolated coefficient
          jfotsout(indexint,11,auxi) = 
-     $        jfotsout(indexint,11,nlayermx) *
+     $        jfotsout(indexint,11,nlayer) *
      $        (wm(i)*auxjco(ind+1) + wp(i)*auxjco(ind))
          !H interpolated coefficient
          jfotsout(indexint,12,auxi) = 
-     $        jfotsout(indexint,12,nlayermx) *
+     $        jfotsout(indexint,12,nlayer) *
      $        (wm(i)*auxjh(ind+1) + wp(i)*auxjh(ind))
       enddo
       !Only if chemthermod.ge.2
       if(chemthermod.ge.2) then
-         do i=1,nlayermx
+         do i=1,nlayer
             ind=auxind(i)
-            auxi = nlayermx-i+1
+            auxi = nlayer-i+1
             !N interpolated coefficient
             jfotsout(indexint,9,auxi) = 
-     $           jfotsout(indexint,9,nlayermx) *
+     $           jfotsout(indexint,9,nlayer) *
      $           (wm(i)*auxjn(ind+1) + wp(i)*auxjn(ind))
             !NO interpolated coefficient
             jfotsout(indexint,10,auxi) = 
-     $           jfotsout(indexint,10,nlayermx) * 
+     $           jfotsout(indexint,10,nlayer) * 
      $           (wm(i)*auxjno(ind+1) + wp(i)*auxjno(ind))
             !NO2 interpolated coefficient
             jfotsout(indexint,13,auxi) = 
-     $           jfotsout(indexint,13,nlayermx) *
+     $           jfotsout(indexint,13,nlayer) *
      $           (wm(i)*auxjno2(ind+1) + wp(i)*auxjno2(ind))
          enddo
@@ -474,6 +475,6 @@
 c     Input column
 
-      do i=1,nlayermx
-         auxcolinp(nlayermx-i+1) = co2colx(i) + o2colx(i) + n2colx(i) +
+      do i=1,nlayer
+         auxcolinp(nlayer-i+1) = co2colx(i) + o2colx(i) + n2colx(i) +
      $        nocolx(i) + cocolx(i) + no2colx(i)
       end do
@@ -508,9 +509,9 @@
 
          call interfast
-     $     (wm,wp,auxind,auxcolinp,nlayermx,auxcoltab,nz2,limdown,limup)
+     $     (wm,wp,auxind,auxcolinp,nlayer,auxcoltab,nz2,limdown,limup)
          !Correction to include T variation of CO2 cross section
          if(indexint.eq.24) then
-            do i=1,nlayermx
-               auxi = nlayermx-i+1
+            do i=1,nlayer
+               auxi = nlayer-i+1
                if(sigma(indexint,auxi)*
      $              alfa(indexint,auxi)*coltemp(auxi)
@@ -523,19 +524,19 @@
             enddo
          else
-            do i=1,nlayermx
+            do i=1,nlayer
                cortemp(i)=1.
             enddo
          end if
-         do i=1,nlayermx           
+         do i=1,nlayer           
             ind=auxind(i)
-            auxi = nlayermx-i+1
+            auxi = nlayer-i+1
             !O2 interpolated coefficient
             jfotsout(indexint,2,auxi) = 
-     $           jfotsout(indexint,2,nlayermx) *
+     $           jfotsout(indexint,2,nlayer) *
      $           (wm(i)*auxjo2(ind+1) + wp(i)*auxjo2(ind)) * 
      $           cortemp(i)
             !CO2 interpolated coefficient
             jfotsout(indexint,1,auxi) = 
-     $           jfotsout(indexint,1,nlayermx) *
+     $           jfotsout(indexint,1,nlayer) *
      $           (wm(i)*auxjco2(ind+1) + wp(i)*auxjco2(ind)) 
      $           * cortemp(i)
@@ -546,10 +547,10 @@
             !N2 interpolated coefficient
             jfotsout(indexint,8,auxi) = 
-     $           jfotsout(indexint,8,nlayermx) *
+     $           jfotsout(indexint,8,nlayer) *
      $           (wm(i)*auxjn2(ind+1) + wp(i)*auxjn2(ind)) * 
      $           cortemp(i)            
             !CO interpolated coefficient
             jfotsout(indexint,11,auxi) = 
-     $           jfotsout(indexint,11,nlayermx) *
+     $           jfotsout(indexint,11,nlayer) *
      $           (wm(i)*auxjco(ind+1) + wp(i)*auxjco(ind)) * 
      $           cortemp(i)            
@@ -557,15 +558,15 @@
          !Only if chemthermod.ge.2
          if(chemthermod.ge.2) then
-            do i=1,nlayermx
+            do i=1,nlayer
                ind=auxind(i)
-               auxi = nlayermx-i+1
+               auxi = nlayer-i+1
                !NO interpolated coefficient
                jfotsout(indexint,10,auxi)=
-     $              jfotsout(indexint,10,nlayermx) *
+     $              jfotsout(indexint,10,nlayer) *
      $              (wm(i)*auxjno(ind+1) + wp(i)*auxjno(ind)) * 
      $              cortemp(i)
                !NO2 interpolated coefficient
                jfotsout(indexint,13,auxi)=
-     $              jfotsout(indexint,13,nlayermx) *
+     $              jfotsout(indexint,13,nlayer) *
      $              (wm(i)*auxjno2(ind+1)+ wp(i)*auxjno2(ind)) * 
      $              cortemp(i)
@@ -586,6 +587,6 @@
 c     Input atmospheric column
 
-      do i=1,nlayermx
-         auxcolinp(nlayermx-i+1) = co2colx(i) + o2colx(i) + h2ocolx(i) + 
+      do i=1,nlayer
+         auxcolinp(nlayer-i+1) = co2colx(i) + o2colx(i) + h2ocolx(i) + 
      $        h2o2colx(i) + nocolx(i) + cocolx(i) + no2colx(i)
       end do
@@ -621,8 +622,8 @@
          endif
          call interfast
-     $     (wm,wp,auxind,auxcolinp,nlayermx,auxcoltab,nz2,limdown,limup)
-         do i=1,nlayermx
+     $     (wm,wp,auxind,auxcolinp,nlayer,auxcoltab,nz2,limdown,limup)
+         do i=1,nlayer
             ind=auxind(i)
-            auxi = nlayermx-i+1
+            auxi = nlayer-i+1
             !Correction to include T variation of CO2 cross section
             if(sigma(indexint,auxi)*alfa(indexint,auxi)*
@@ -635,5 +636,5 @@
             !CO2 interpolated coefficient
             jfotsout(indexint,1,auxi) = 
-     $           jfotsout(indexint,1,nlayermx) *
+     $           jfotsout(indexint,1,nlayer) *
      $           (wm(i)*auxjco2(ind+1) + wp(i)*auxjco2(ind)) * 
      $           cortemp(i) *
@@ -642,20 +643,20 @@
             !O2 interpolated coefficient
             jfotsout(indexint,2,auxi) = 
-     $           jfotsout(indexint,2,nlayermx) *
+     $           jfotsout(indexint,2,nlayer) *
      $           (wm(i)*auxjo2(ind+1) + wp(i)*auxjo2(ind)) * 
      $           cortemp(i)
             !H2O interpolated coefficient
             jfotsout(indexint,4,auxi) = 
-     $           jfotsout(indexint,4,nlayermx) *
+     $           jfotsout(indexint,4,nlayer) *
      $           (wm(i)*auxjh2o(ind+1) + wp(i)*auxjh2o(ind)) * 
      $           cortemp(i)
             !H2O2 interpolated coefficient
             jfotsout(indexint,6,auxi) = 
-     $           jfotsout(indexint,6,nlayermx) *
+     $           jfotsout(indexint,6,nlayer) *
      $           (wm(i)*auxjh2o2(ind+1) + wp(i)*auxjh2o2(ind)) * 
      $           cortemp(i)            
             !CO interpolated coefficient
             jfotsout(indexint,11,auxi) = 
-     $           jfotsout(indexint,11,nlayermx) *
+     $           jfotsout(indexint,11,nlayer) *
      $           (wm(i)*auxjco(ind+1) + wp(i)*auxjco(ind)) * 
      $           cortemp(i)
@@ -663,15 +664,15 @@
          !Only if chemthermod.ge.2
          if(chemthermod.ge.2) then
-            do i=1,nlayermx
+            do i=1,nlayer
                ind=auxind(i)
-               auxi = nlayermx-i+1
+               auxi = nlayer-i+1
                !NO interpolated coefficient
                jfotsout(indexint,10,auxi)=
-     $              jfotsout(indexint,10,nlayermx) *
+     $              jfotsout(indexint,10,nlayer) *
      $              (wm(i)*auxjno(ind+1) + wp(i)*auxjno(ind)) * 
      $              cortemp(i)
                !NO2 interpolated coefficient
                jfotsout(indexint,13,auxi)=
-     $              jfotsout(indexint,13,nlayermx) *
+     $              jfotsout(indexint,13,nlayer) *
      $              (wm(i)*auxjno2(ind+1) + wp(i)*auxjno2(ind)) * 
      $              cortemp(i)
@@ -694,6 +695,6 @@
 c     Input atmospheric column
 
-      do i=1,nlayermx
-         auxcolinp(nlayermx-i+1) = co2colx(i) + o2colx(i) + h2ocolx(i) + 
+      do i=1,nlayer
+         auxcolinp(nlayer-i+1) = co2colx(i) + o2colx(i) + h2ocolx(i) + 
      $        h2o2colx(i) + nocolx(i) + no2colx(i)
       end do
@@ -728,8 +729,8 @@
 
          call interfast
-     $     (wm,wp,auxind,auxcolinp,nlayermx,auxcoltab,nz2,limdown,limup)
-         do i=1,nlayermx
+     $     (wm,wp,auxind,auxcolinp,nlayer,auxcoltab,nz2,limdown,limup)
+         do i=1,nlayer
             ind=auxind(i)
-            auxi = nlayermx-i+1
+            auxi = nlayer-i+1
             !Correction to include T variation of CO2 cross section
             if(sigma(indexint,auxi)*alfa(indexint,auxi)*
@@ -742,5 +743,5 @@
             !CO2 interpolated coefficient
             jfotsout(indexint,1,auxi) = 
-     $           jfotsout(indexint,1,nlayermx) *
+     $           jfotsout(indexint,1,nlayer) *
      $           (wm(i)*auxjco2(ind+1) + wp(i)*auxjco2(ind)) * 
      $           cortemp(i) *
@@ -749,15 +750,15 @@
             !O2 interpolated coefficient
             jfotsout(indexint,2,auxi) = 
-     $           jfotsout(indexint,2,nlayermx) *
+     $           jfotsout(indexint,2,nlayer) *
      $           (wm(i)*auxjo2(ind+1) + wp(i)*auxjo2(ind)) * 
      $           cortemp(i)
             !H2O interpolated coefficient
             jfotsout(indexint,4,auxi) = 
-     $           jfotsout(indexint,4,nlayermx) *
+     $           jfotsout(indexint,4,nlayer) *
      $           (wm(i)*auxjh2o(ind+1) + wp(i)*auxjh2o(ind)) * 
      $           cortemp(i)
             !H2O2 interpolated coefficient
             jfotsout(indexint,6,auxi) = 
-     $           jfotsout(indexint,6,nlayermx) *
+     $           jfotsout(indexint,6,nlayer) *
      $           (wm(i)*auxjh2o2(ind+1) + wp(i)*auxjh2o2(ind)) * 
      $           cortemp(i)            
@@ -765,10 +766,10 @@
          !Only if chemthermod.ge.2
          if(chemthermod.ge.2) then
-            do i=1,nlayermx 
+            do i=1,nlayer 
                ind=auxind(i)
-               auxi = nlayermx-i+1
+               auxi = nlayer-i+1
                !NO interpolated coefficient
                jfotsout(indexint,10,auxi)=
-     $              jfotsout(indexint,10,nlayermx) *
+     $              jfotsout(indexint,10,nlayer) *
      $              (wm(i)*auxjno(ind+1) +wp(i)*auxjno(ind)) * 
      $              cortemp(i)
@@ -796,6 +797,6 @@
 
       indexint=32
-      do i=1,nlayermx
-         auxcolinp(nlayermx-i+1) =co2colx(i) + o2colx(i) + h2o2colx(i) + 
+      do i=1,nlayer
+         auxcolinp(nlayer-i+1) =co2colx(i) + o2colx(i) + h2o2colx(i) + 
      $        nocolx(i) + no2colx(i)
       end do
@@ -825,10 +826,10 @@
       endif
       call interfast
-     $     (wm,wp,auxind,auxcolinp,nlayermx,auxcoltab,nz2,limdown,limup)
-      do i=1,nlayermx
+     $     (wm,wp,auxind,auxcolinp,nlayer,auxcoltab,nz2,limdown,limup)
+      do i=1,nlayer
          ind=auxind(i)
-         auxi = nlayermx-i+1
+         auxi = nlayer-i+1
          !Correction to include T variation of CO2 cross section
-         if(sigma(indexint,nlayermx-i+1)*alfa(indexint,auxi)*
+         if(sigma(indexint,nlayer-i+1)*alfa(indexint,auxi)*
      $        coltemp(auxi).lt.60.) then
             cortemp(i)=exp(-sigma(indexint,auxi)*
@@ -839,5 +840,5 @@
          !CO2 interpolated coefficient
          jfotsout(indexint,1,auxi) = 
-     $        jfotsout(indexint,1,nlayermx) *
+     $        jfotsout(indexint,1,nlayer) *
      $        (wm(i)*auxjco2(ind+1)+wp(i)*auxjco2(ind)) * 
      $        cortemp(i) *
@@ -846,10 +847,10 @@
          !O2 interpolated coefficient
          jfotsout(indexint,2,auxi) = 
-     $        jfotsout(indexint,2,nlayermx) *
+     $        jfotsout(indexint,2,nlayer) *
      $        (wm(i)*auxjo2(ind+1) + wp(i)*auxjo2(ind)) * 
      $        cortemp(i)
          !H2O2 interpolated coefficient
          jfotsout(indexint,6,auxi) = 
-     $        jfotsout(indexint,6,nlayermx) *
+     $        jfotsout(indexint,6,nlayer) *
      $        (wm(i)*auxjh2o2(ind+1) + wp(i)*auxjh2o2(ind)) * 
      $        cortemp(i)         
@@ -857,15 +858,15 @@
       !Only if chemthermod.ge.2
       if(chemthermod.ge.2) then
-         do i=1,nlayermx
-            auxi = nlayermx-i+1
+         do i=1,nlayer
+            auxi = nlayer-i+1
             ind=auxind(i)
             !NO interpolated coefficient
             jfotsout(indexint,10,auxi) = 
-     $           jfotsout(indexint,10,nlayermx) * 
+     $           jfotsout(indexint,10,nlayer) * 
      $           (wm(i)*auxjno(ind+1) + wp(i)*auxjno(ind)) * 
      $           cortemp(i)
            !NO2 interpolated coefficient
             jfotsout(indexint,13,auxi) = 
-     $           jfotsout(indexint,13,nlayermx) *
+     $           jfotsout(indexint,13,nlayer) *
      $           (wm(i)*auxjno2(ind+1) + wp(i)*auxjno2(ind)) * 
      $           cortemp(i)
@@ -886,6 +887,6 @@
 
       indexint=33
-      do i=1,nlayermx
-         auxcolinp(nlayermx-i+1) = o2colx(i) + h2o2colx(i) + no2colx(i)
+      do i=1,nlayer
+         auxcolinp(nlayer-i+1) = o2colx(i) + h2o2colx(i) + no2colx(i)
       end do
 
@@ -909,22 +910,22 @@
       endif
       call interfast
-     $     (wm,wp,auxind,auxcolinp,nlayermx,auxcoltab,nz2,limdown,limup)
-      do i=1,nlayermx
+     $     (wm,wp,auxind,auxcolinp,nlayer,auxcoltab,nz2,limdown,limup)
+      do i=1,nlayer
          ind=auxind(i)
-         auxi = nlayermx-i+1
+         auxi = nlayer-i+1
          !O2 interpolated coefficient
-         jfotsout(indexint,2,auxi) = jfotsout(indexint,2,nlayermx) *
+         jfotsout(indexint,2,auxi) = jfotsout(indexint,2,nlayer) *
      $        (wm(i)*auxjo2(ind+1) + wp(i)*auxjo2(ind))
          !H2O2 interpolated coefficient
-         jfotsout(indexint,6,auxi) = jfotsout(indexint,6,nlayermx) *
+         jfotsout(indexint,6,auxi) = jfotsout(indexint,6,nlayer) *
      $        (wm(i)*auxjh2o2(ind+1) + wp(i)*auxjh2o2(ind))
       enddo
       !Only if chemthermod.ge.2
       if(chemthermod.ge.2) then
-         do i=1,nlayermx
+         do i=1,nlayer
             ind=auxind(i)
             !NO2 interpolated coefficient
-            jfotsout(indexint,13,nlayermx-i+1) = 
-     $           jfotsout(indexint,13,nlayermx) *
+            jfotsout(indexint,13,nlayer-i+1) = 
+     $           jfotsout(indexint,13,nlayer) *
      $           (wm(i)*auxjno2(ind+1) + wp(i)*auxjno2(ind))
          enddo
@@ -944,6 +945,6 @@
 
       indexint=34
-      do i=1,nlayermx
-         auxcolinp(nlayermx-i+1) = h2o2colx(i) + o2colx(i) + o3colx(i) + 
+      do i=1,nlayer
+         auxcolinp(nlayer-i+1) = h2o2colx(i) + o2colx(i) + o3colx(i) + 
      $        no2colx(i)
       end do
@@ -970,25 +971,25 @@
       endif
       call interfast
-     $     (wm,wp,auxind,auxcolinp,nlayermx,auxcoltab,nz2,limdown,limup)
-      do i=1,nlayermx
+     $     (wm,wp,auxind,auxcolinp,nlayer,auxcoltab,nz2,limdown,limup)
+      do i=1,nlayer
          ind=auxind(i)
-         auxi = nlayermx-i+1
+         auxi = nlayer-i+1
          !O2 interpolated coefficient
-         jfotsout(indexint,2,auxi) = jfotsout(indexint,2,nlayermx) * 
+         jfotsout(indexint,2,auxi) = jfotsout(indexint,2,nlayer) * 
      $        (wm(i)*auxjo2(ind+1) + wp(i)*auxjo2(ind))
          !H2O2 interpolated coefficient
-         jfotsout(indexint,6,auxi) = jfotsout(indexint,6,nlayermx) *
+         jfotsout(indexint,6,auxi) = jfotsout(indexint,6,nlayer) *
      $        (wm(i)*auxjh2o2(ind+1) + wp(i)*auxjh2o2(ind))
          !O3 interpolated coefficient
-         jfotsout(indexint,7,auxi) = jfotsout(indexint,7,nlayermx) *
+         jfotsout(indexint,7,auxi) = jfotsout(indexint,7,nlayer) *
      $        (wm(i)*auxjo3(ind+1) + wp(i)*auxjo3(ind))
       enddo
       !Only if chemthermod.ge.2
       if(chemthermod.ge.2) then
-         do i=1,nlayermx
+         do i=1,nlayer
             ind=auxind(i)
             !NO2 interpolated coefficient
-            jfotsout(indexint,13,nlayermx-i+1) = 
-     $           jfotsout(indexint,13,nlayermx) *
+            jfotsout(indexint,13,nlayer-i+1) = 
+     $           jfotsout(indexint,13,nlayer) *
      $           (wm(i)*auxjno2(ind+1) + wp(i)*auxjno2(ind))
          enddo
@@ -1008,6 +1009,6 @@
 
       indexint=35
-      do i=1,nlayermx
-         auxcolinp(nlayermx-i+1) = h2o2colx(i) + o3colx(i) + no2colx(i)
+      do i=1,nlayer
+         auxcolinp(nlayer-i+1) = h2o2colx(i) + o3colx(i) + no2colx(i)
       end do
 
@@ -1031,21 +1032,21 @@
       endif
       call interfast
-     $     (wm,wp,auxind,auxcolinp,nlayermx,auxcoltab,nz2,limdown,limup)
-      do i=1,nlayermx
+     $     (wm,wp,auxind,auxcolinp,nlayer,auxcoltab,nz2,limdown,limup)
+      do i=1,nlayer
          ind=auxind(i)
-         auxi = nlayermx-i+1
+         auxi = nlayer-i+1
          !H2O2 interpolated coefficient
-         jfotsout(indexint,6,auxi) = jfotsout(indexint,6,nlayermx) *
+         jfotsout(indexint,6,auxi) = jfotsout(indexint,6,nlayer) *
      $        (wm(i)*auxjh2o2(ind+1) + wp(i)*auxjh2o2(ind))
          !O3 interpolated coefficient
-         jfotsout(indexint,7,auxi) = jfotsout(indexint,7,nlayermx) *
+         jfotsout(indexint,7,auxi) = jfotsout(indexint,7,nlayer) *
      $        (wm(i)*auxjo3(ind+1) + wp(i)*auxjo3(ind))
       enddo
       if(chemthermod.ge.2) then
-         do i=1,nlayermx
+         do i=1,nlayer
             ind=auxind(i)
             !NO2 interpolated coefficient
-            jfotsout(indexint,13,nlayermx-i+1) = 
-     $           jfotsout(indexint,13,nlayermx) *
+            jfotsout(indexint,13,nlayer-i+1) = 
+     $           jfotsout(indexint,13,nlayer) *
      $           (wm(i)*auxjno2(ind+1) + wp(i)*auxjno2(ind))
          enddo
@@ -1064,6 +1065,6 @@
 
       indexint=36
-      do i=1,nlayermx
-         auxcolinp(nlayermx-i+1) = o3colx(i) + no2colx(i)
+      do i=1,nlayer
+         auxcolinp(nlayer-i+1) = o3colx(i) + no2colx(i)
       end do
 
@@ -1085,19 +1086,19 @@
       endif
       call interfast
-     $     (wm,wp,auxind,auxcolinp,nlayermx,auxcoltab,nz2,limdown,limup)
-      do i=1,nlayermx
+     $     (wm,wp,auxind,auxcolinp,nlayer,auxcoltab,nz2,limdown,limup)
+      do i=1,nlayer
          ind=auxind(i)
          !O3 interpolated coefficient
-         jfotsout(indexint,7,nlayermx-i+1) = 
-     $        jfotsout(indexint,7,nlayermx) *
+         jfotsout(indexint,7,nlayer-i+1) = 
+     $        jfotsout(indexint,7,nlayer) *
      $        (wm(i)*auxjo3(ind+1) + wp(i)*auxjo3(ind))
       enddo
       !Only if chemthermod.ge.2
       if(chemthermod.ge.2) then
-         do i=1,nlayermx
+         do i=1,nlayer
             ind=auxind(i)
             !NO2 interpolated coefficient
-            jfotsout(indexint,13,nlayermx-i+1) = 
-     $           jfotsout(indexint,13,nlayermx) *
+            jfotsout(indexint,13,nlayer-i+1) = 
+     $           jfotsout(indexint,13,nlayer) *
      $           (wm(i)*auxjno2(ind+1) + wp(i)*auxjno2(ind))
          enddo
